﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Windows.Threading;

namespace SilverlightApplication1
{
	public partial class MainPage : UserControl
	{
		private DispatcherTimer doubleClickTimer = new DispatcherTimer();
		private bool doubleClickFlag;
		
		public MainPage()
		{
			InitializeComponent();
			this.doubleClickTimer.Interval = TimeSpan.FromMilliseconds(200);
			this.doubleClickTimer.Tick += new EventHandler(doubleClickTimer_Tick);
			this.treeView1.AddHandler(RadTreeViewItem.MouseLeftButtonDownEvent, new MouseButtonEventHandler(treeView1_MouseLeftButtonDown), true);
		}

		// First get the selected item
		// Check whether the selected item has sub-items and if so, 
		// check whether the doubleClickFlag has been raised -> display MessageBox
		// else start the doubleClickTimer and raise the flag
		void treeView1_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
		{
			RadTreeViewItem selectedItem = treeView1.SelectedItem as RadTreeViewItem;
			if (selectedItem != null && selectedItem.Items.Count == 0)
			{
				if (this.doubleClickFlag)
				{
					MessageBox.Show("Wow");
				}
				else
				{
					this.doubleClickTimer.Start();
					this.doubleClickFlag = true;
				}
			}
		}

		// The double-click interval has expired, therefore stop the timer and lower the flag
		void doubleClickTimer_Tick(object sender, EventArgs e)
		{
			this.doubleClickTimer.Stop();
			this.doubleClickFlag = false;
		}
	}
}
